﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Charting;
using Telerik.Windows.Controls.ChartView;

namespace SLApp
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }
    }

    public class ViewModel : ViewModelBase
    {
        public ObservableCollection<PlotInfo> Data { get; private set; }

        private DateTime periodStart;
        public DateTime PeriodStart
        {
            get
            {
                return periodStart;
            }
            set
            {
                if (periodStart == value)
                    return;
 
                periodStart = value;
                this.OnPropertyChanged("PeriodStart");
            }
        }

        private DateTime periodEnd;
        public DateTime PeriodEnd
        {
            get
            {
                return periodEnd;
            }
            set
            {
                if (periodEnd == value)
                    return;
 
                periodEnd = value;
                this.OnPropertyChanged("PeriodEnd");
                this.OnPropertyChanged("ChartPeriodEnd");
            }
        }

        public DateTime ChartPeriodEnd
        {
        	get
        	{
                //The range of the chart horizontal axis includes the maximum as a tick
                //as oposed to the TimeBar which does not include its PeriodEnd
                return this.periodEnd.AddMonths(-1);
        	}
        }

        public ViewModel()
        {
            this.periodStart = new DateTime(2013, 3, 1);
            this.periodEnd = new DateTime(2013, 6, 15); //add offset so the last TimeBar interval label can be shown

            this.Data = GetTestData(3);
        }

        public ObservableCollection<PlotInfo> GetTestData(int dataSize)
        {
            var result = new ObservableCollection<PlotInfo>();

            result.Add(new PlotInfo { Date = this.periodStart.AddMonths(0), Value1 = 3, Value2 = 6 });
            result.Add(new PlotInfo { Date = this.periodStart.AddMonths(1), Value1 = 10, Value2 = 5 });
            result.Add(new PlotInfo { Date = this.periodStart.AddMonths(2), Value1 = 7, Value2 = 4 });

            return result;
        }
    }

    public class PlotInfo
    {
        public DateTime Date { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
    }
}